--- cdda2wav/interface.c.orig
+++ cdda2wav/interface.c
@@ -439,13 +439,21 @@
 #endif
 #endif
        break;
-#if defined (__linux__) || defined (__FreeBSD__)
+#if defined (__linux__) || defined (__FreeBSD__) || defined(__DragonFly__)
 #if defined (__linux__)
     case SCSI_CDROM_MAJOR:     /* scsi cd */
     default:			/* for example ATAPI cds */
 #else
-#if defined (__FreeBSD__)
-    case 117:
+#if defined (__FreeBSD__) || defined(__DragonFly__)
+#if __FreeBSD_version >= 501113
+    case 4:	/* GEOM */
+	if (memcmp(pdev_name, "/dev/acd", sizeof("/dev/acd") - 1) != 0) {
+	    fprintf(stderr, "%s is not an ATAPI CDROM device\n", pdev_name);
+	    exit(SYNTAX_ERROR);
+	}
+	/* FALLTHROUGH */
+#endif
+    case 117:	/* pre-GEOM atapi cd */
 	if (!S_ISCHR(statstruct->st_mode)) {
 	    fprintf(stderr, "%s is not a char device\n",pdev_name);
 	    exit(SYNTAX_ERROR);
